function [dx]=forwardx_nb(u)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Forward difference operator in the x-direction for the input 
% matrix u, which is assumed to be buffered (layer thickness 2). 
% Periodic boundary conditions used.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Uses: upbuffer2nb.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

u = padnb(u,2);
[m,n]=size(u);	% Buffered size.
m=m-4;		% Find the unbuffered size.
n=n-4;		% Find the unbuffered size.

dx=u;		% Initialization for dx.

% Carry out operation on unbuffered part of u:
dx(3:m+2,3:n+2)=( u(3:m+2,4:n+3) - u(3:m+2,3:n+2) );

% Update the buffer region:
dx=upbuffer2nb(dx);

dx = dx(3:m+2,3:n+2); %extract unbuffered region
