function [ubo]=upadnb1(ub,L)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function updates the buffer layer of a buffered vector, 
% using homog neumann (reflection) bc, where the buffer layer thickness is L. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Notes: No error checking is built in. Make sure size of input
%	 matrix is large enough: both dims. > 2 needed.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[mb,nb]=size(ub); %buffered vector size

if mb==1
    m=1;
    n=nb-2*L;
    %left reflect
    ub(m,1:L)= ub(m,L+L:-1:L+1);
    %
    %right reflect
    ub(m,L+n+1:L+n+L)= ub(m,L+n:-1:L+n-L+1);
    
elseif nb==1
    n=1;
    m = mb-2*L;
    %top reflect
    ub(1:L,n)= ub(L+L:-1:L+1,n);
    %
    %bottom reflect
    ub(L+m+1:L+m+L,n)= ub(L+m:-1:L+m-L+1,n);
else 
    disp('error in vector size')
    return
end
    
%m=size(ub,1)-2*L;
%n=size(ub,2)-2*L;

% Update the buffer:

%neumann 2
%ub(3:m+2,1:2)=ub(3:m+2,5:-1:4);
%ub(3:m+2,n+3:n+4)=ub(3:m+2,n+3:-1:n+2);
%ub(1:2,1:n+4)=ub(5:-1:4,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(m+3:-1:m+2,1:n+4);

% %neumann 1
% %left reflect
% ub(L+1:L+m,1:L)= ub(L+1:L+m,L+L:-1:L+1);
% 
% %right reflect
% ub(L+1:L+m,L+n+1:L+n+L)= ub(L+1:L+m,L+n:-1:L+n-L+1);


% %top reflect
% ub(1:L,1:n+2*L)= ub(L+L:-1:L+1,1:n+2*L);
% 
% %bottom reflect
% ub(L+m+1:L+m+L,1:n+2*L)= ub(L+m:-1:L+m-L+1,1:n+2*L);


ubo=ub;
