function [ubo]=upbuffer2(ub)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function updates the buffer layer of a buffered matrix, 
% using periodicity, where the buffer layer thickness is 2. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Notes: No error checking is built in. Make sure size of input
%	 matrix is large enough: both dims. > 4 needed.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m=size(ub,1)-4;
n=size(ub,2)-4;

% Update the buffer:

ub(3:m+2,1:2)=ub(3:m+2,n+1:n+2);
ub(3:m+2,n+3:n+4)=ub(3:m+2,3:4);
ub(1:2,1:n+4)=ub(m+1:m+2,1:n+4);
ub(m+3:m+4,1:n+4)=ub(3:4,1:n+4);

ubo=ub;
