function [ubo]=upbuffer2nb(ub)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function updates the buffer layer of a buffered matrix, 
% using homog neumann (reflection) bc, where the buffer layer thickness is 2. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Notes: No error checking is built in. Make sure size of input
%	 matrix is large enough: both dims. > 4 needed.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m=size(ub,1)-4;
n=size(ub,2)-4;

% Update the buffer:

%neumann 2
%ub(3:m+2,1:2)=ub(3:m+2,5:-1:4);
%ub(3:m+2,n+3:n+4)=ub(3:m+2,n+3:-1:n+2);
%ub(1:2,1:n+4)=ub(5:-1:4,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(m+3:-1:m+2,1:n+4);

%neumann 1
ub(3:m+2,1:2)=ub(3:m+2,4:-1:3);
ub(3:m+2,n+3:n+4)=ub(3:m+2,n+2:-1:n+1);
ub(1:2,1:n+4)=ub(4:-1:3,1:n+4);
ub(m+3:m+4,1:n+4)=ub(m+2:-1:m+1,1:n+4);




% previous periodic bc
%ub(3:m+2,1:2)=ub(3:m+2,n+1:n+2);
%ub(3:m+2,n+3:n+4)=ub(3:m+2,3:4);
%ub(1:2,1:n+4)=ub(m+1:m+2,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(3:4,1:n+4);

ubo=ub;
